// Sample communication Code for RS 485 Shield with Arduino Mega 2560
#define RS485_OE_1 22 //RS485 CH#1 Output Enable => pin 22 for CH#1
#define Snd_485 HIGH
#define Rcv_485 LOW

void MC9_setup(){
  Serial1.setTimeout(300);
  Serial1.begin(9600);
  pinMode(RS485_OE_1, OUTPUT);
  delay(10);
  digitalWrite(RS485_OE_1, Rcv_485);
}

void read_mc9_req(){
  if(!Wait_485){
    String command = "10DRS,03,0011C7\r\n";

    // Send request to return pv data
    digitalWrite(RS485_OE_1, Snd_485); delay(5);
    Serial1.print(command);
    Serial1.flush();
    digitalWrite(RS485_OE_1, Rcv_485); delay(5);
    Wait_485 = true;
    Wait_485_cnt = 0;
  }
}

void read_mc9(int arr[], int size){
  char c;
  String message;

  // Timeout code
  if(Wait_485){
    Wait_485_cnt++;
    if(Wait_485_cnt > 200){ // Timeout = periodic(10ms) x 200 = 2sec
      Wait_485 = false;
      Wait_485_cnt = 0;
    }
  }
  // Receive pv data
  while(Wait_485 && (Serial1.available() > 0)) {
    c = Serial1.read();
    Buf_485 += c;
    Serial.print(c, HEX);
    Serial.print(" ");

    if(c == '\n'){
      message = Buf_485;
      Buf_485 = "";
      Wait_485 = false;
      Wait_485_cnt = 0;
    }
  }

  if(message != ""){
    Serial.println(message);  
  }

}

void write_mc9(int arr[], int size){
  cli();//stop interrupts
  Serial1.print("485 Write^^");          //Serial Write ADC_Value to RS-485 Bus
  sei();//allow interrupts
}